package br.com.evologica.mvp.data;

import android.content.Context;

import javax.inject.Inject;
import javax.inject.Singleton;

import br.com.evologica.mvp.data.db.DbHelper;
import br.com.evologica.mvp.data.network.ApiHelper;
import br.com.evologica.mvp.data.prefs.PreferencesHelper;
import br.com.evologica.mvp.di.ApplicationContext;

/**
 * Created by marcussales on 01/03/2017.
 */

@Singleton
public class AppDataManager implements DataManager {

    private static final String TAG = "AppDataManager";

    private final Context context;
    private final ApiHelper apiHelper;
    private final DbHelper dbHelper;
    private final PreferencesHelper preferencesHelper;

    @Inject
    public AppDataManager(@ApplicationContext Context ctx,
                          ApiHelper apiHelper,
                          DbHelper dbHelper,
                          PreferencesHelper preferencesHelper) {
        this.context = ctx;
        this.apiHelper = apiHelper;
        this.dbHelper = dbHelper;
        this.preferencesHelper = preferencesHelper;
    }

    @Override
    public void closeSession() {
        apiHelper.closeSession();
    }

}
