package br.com.evologica.mvp.di.module;

import android.app.Application;
import android.content.Context;

import javax.inject.Singleton;

import br.com.evologica.curio.CurioConfig;
import br.com.evologica.curio.Service;
import br.com.evologica.mvp.BuildConfig;
import br.com.evologica.mvp.data.AppDataManager;
import br.com.evologica.mvp.data.DataManager;
import br.com.evologica.mvp.data.db.AppDbHelper;
import br.com.evologica.mvp.data.db.DbHelper;
import br.com.evologica.mvp.data.network.ApiHelper;
import br.com.evologica.mvp.data.network.AppApiHelper;
import br.com.evologica.mvp.data.prefs.AppPreferencesHelper;
import br.com.evologica.mvp.data.prefs.PreferencesHelper;
import br.com.evologica.mvp.di.ApplicationContext;
import br.com.evologica.mvp.di.DatabaseInfo;
import br.com.evologica.mvp.di.PreferenceInfo;
import br.com.evologica.mvp.utils.AppConstants;
import dagger.Module;
import dagger.Provides;

/**
 * Created by marcussales on 02/03/2017.
 */

@Module
public class ApplicationModule {

    private final Application mApplication;

    public ApplicationModule(Application application) {
        mApplication = application;
    }

    @Provides
    @ApplicationContext
    Context provideContext() {
        return mApplication;
    }

    @Provides
    Application provideApplication() {
        return mApplication;
    }

    @Provides
    @Singleton
    DataManager provideDataManager(AppDataManager appDataManager){
        return appDataManager;
    }

    @Provides
    @Singleton
    ApiHelper provideApiHelper(AppApiHelper appApiHelper) {
        return appApiHelper;
    }

    @Provides
    @Singleton
    DbHelper provideDbHelper(AppDbHelper appDbHelper) {
        return appDbHelper;
    }

    @Provides
    @Singleton
    PreferencesHelper providePreferencesHelper(AppPreferencesHelper appPreferencesHelper){
        return appPreferencesHelper;
    }

    @Provides
    @PreferenceInfo
    String providePreferenceName(){
        return AppConstants.PREF_NAME;
    }

    @Provides
    @DatabaseInfo
    String provideDatabaseName() {
        return AppConstants.DB_NAME;
    }

    @Provides
    @Singleton
    Service provideCurioService() {
        if(BuildConfig.BUILD_TYPE.equals("release")) {
            CurioConfig config = new CurioConfig("192.168.0.34", "6161", "72");
            return new Service("CentralBonus", config);
        }else {
            CurioConfig config = new CurioConfig("192.168.0.34", "6161", "72");
            return new Service("CentralBonus", config);
        }
    }

}
